codeforces 814A

来源:互联网 发布:淘宝好评卡片 编辑:程序博客网 时间:2024/05/16 17:01
A. An abandoned sentiment from past
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

A few years ago, Hitagi encountered a giant crab, who stole the whole of her body weight. Ever since, she tried to avoid contact with others, for fear that this secret might be noticed.

To get rid of the oddity and recover her weight, a special integer sequence is needed. Hitagi's sequence has been broken for a long time, but now Kaiki provides an opportunity.

Hitagi's sequence a has a length of n. Lost elements in it are denoted by zeros. Kaiki provides another sequence b, whose length kequals the number of lost elements in a (i.e. the number of zeros). Hitagi is to replace each zero in a with an element from b so that each element in b should be used exactly once. Hitagi knows, however, that, apart from 0, no integer occurs in a and b more than once in total.

If the resulting sequence is not an increasing sequence, then it has the power to recover Hitagi from the oddity. You are to determine whether this is possible, or Kaiki's sequence is just another fake. In other words, you should detect whether it is possible to replace each zero in a with an integer from b so that each integer from b is used exactly once, and the resulting sequence is not increasing.

Input

The first line of input contains two space-separated positive integers n (2 ≤ n ≤ 100) and k (1 ≤ k ≤ n) — the lengths of sequence a and b respectively.

The second line contains n space-separated integers a1, a2, ..., an (0 ≤ ai ≤ 200) — Hitagi's broken sequence with exactly k zero elements.

The third line contains k space-separated integers b1, b2, ..., bk (1 ≤ bi ≤ 200) — the elements to fill into Hitagi's sequence.

Input guarantees that apart from 0, no integer occurs in a and b more than once in total.

Output

Output "Yes" if it's possible to replace zeros in a with elements in b and make the resulting sequence not increasing, and "No" otherwise.

Examples
input
4 211 0 0 145 4
output
Yes
input
6 12 3 0 8 9 105
output
No
input
4 18 94 0 489
output
Yes
input
7 70 0 0 0 0 0 01 2 3 4 5 6 7
output
Yes
Note

In the first sample:

  • Sequence a is 11, 0, 0, 14.
  • Two of the elements are lost, and the candidates in b are 5 and 4.
  • There are two possible resulting sequences: 11, 5, 4, 14 and 11, 4, 5, 14, both of which fulfill the requirements. Thus the answer is "Yes".

In the second sample, the only possible resulting sequence is 2, 3, 5, 8, 9, 10, which is an increasing sequence and therefore invalid.

题意:给你一个串a和串b,其中串a中有些数字是0,这些位置数字就需要被替换为串b中的元素,替换顺序任意,问你任意替换完成之后串a是否为一个单调递增的串。

思路:如果考虑不能成为递增串情况很多,反向考虑就是能成为递增串的条件,想清楚一个情况,当且仅当a中0个数小于等于1时不管怎样替换之后才能成为一个单调递增的串。0位置就有三种情况:两数中间,最前,最后。然后就可以完成任务了。

代码:

#include<bits/stdc++.h>using namespace std;const int maxn=205;int a[maxn],b[maxn];int main(){    int n,m,x;    while(scanf("%d%d",&n,&m)!=EOF)    {        memset(a,0,sizeof(a));        memset(b,0,sizeof(b));        int flag=0;        int num=0;        int cnt=0;        for(int i=1;i<=n;i++)        {            scanf("%d",&a[i]);            if(a[i]==0) num++;        }        if(num<=1)        {            for(int i=1;i<=n;i++)            {                if(a[i]==0)                {                    cnt=i;                    continue;                }                if(a[i]>a[i+1]&&a[i+1]!=0)                {                    flag=1;                    break;                }            }        }        else flag=1;        for(int i=1;i<=m;i++)        {            scanf("%d",&x);        }        if(flag||m>1)        {            puts("Yes");        }        else        {            if(a[cnt-1]<x&&a[cnt+1]>x||(num<=1&&cnt==0&&a[cnt+1]>x)||(cnt==n&&x>a[cnt-1])) puts("No");            else puts("Yes");        }    }    return 0;}